/*
 * GWT-Ext Widget Library
 * Copyright 2007 - 2008, GWT-Ext LLC., and individual contributors as indicated
 * by the @authors tag. See the copyright.txt in the distribution for a
 * full listing of individual contributors.
 *
 * This is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Lesser General Public License as
 * published by the Free Software Foundation; either version 3 of
 * the License, or (at your option) any later version.
 *
 * This software is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this software; if not, write to the Free
 * Software Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA
 * 02110-1301 USA, or see the FSF site: http://www.fsf.org.
 */
 

package com.gwtext.client.widgets.event;

import com.gwtext.client.widgets.Panel;
import com.gwtext.client.widgets.TabPanel;
import com.gwtext.client.core.EventObject;

/**
 *
 * @author Sanjiv Jivan
 */
public interface TabPanelListener extends PanelListener {

    /**
     * Fires before the active tab changes. Return false to cancel the tab change.
     *
     * @param source this
     * @param newPanel the new panel
     * @param oldPanel the old panel
     * @return false to cancel the tab change
     */
    boolean doBeforeTabChange(TabPanel source, Panel newPanel, Panel oldPanel);

    /**
     * Fires when the contextmenu event originated from a tab element.
     *
     * @param source this
     * @param tab the tab
     * @param e the event object
     */
    void onContextMenu(TabPanel source, Panel tab, EventObject e);

    /**
     * Fires after the active tab has changed.
     *
     * @param source this
     * @param tab the selected tab
     */
    void onTabChange(TabPanel source, Panel tab);
}
